<template>
  <div>
    <br>
    <legend>Datos del encargo.</legend>
    <div class="row">
      <div class="col-md-6 form-group" v-if="mostrarCampos">
        <label class="control-label">
          Nivel/Orden de Gobierno:
        </label>
        <br>
        <el-select clearable class="select-default" placeholder="Nivel" name="nivel_orden" v-validate="modelValidations.nivel_orden" v-model="model.nivel_gobierno_id">
          <el-option v-for="option in niveles" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="nivel_orden.invalid">
          {{ getError('nivel_orden') }}
        </small>
      </div>

      <div class="col-md-6 form-group" v-if="mostrarCampos">
        <label class="control-label">
          Ámbito público
          <!--Poder/Naturaleza jurídica-->
        </label><br>
        <el-select clearable class="select-default" placeholder="Poder" name="poder" v-validate="modelValidations.poder" v-model="model.poder_juridico_id">
          <el-option v-for="option in poderes" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="poder.invalid">
          {{ getError('poder') }}
        </small>
      </div>

      <div class="col-md-12 form-group">
        <label class="control-label">
          Nombre del ente público
        </label><br>
        <el-select disabled clearable class="select-default" filterable name="ente" v-validate="modelValidations.ente" placeholder="Nombre del ente público" v-model="model.ente_publico_id">
          <el-option v-for="option in entes" class="select-default" :value="option.id" :label="option.valor" :key="option.valor">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="ente.invalid">
          {{ getError('ente') }}
        </small>
      </div>


    </div>
    <div class="row">
      <div class="col-md-3 form-group">
        <label class="control-label">
          Área
        </label>
        <br>
        <input class="form-control" type="text" name="area" v-validate="modelValidations.area" v-model="model.area_adscripcion" placeholder="Area de adscripción" />
        <small class="text-danger" v-show="area.invalid">
          {{ getError('area') }}
        </small>
      </div>
      <div class="col-md-3 form-group">
        <label class="control-label">
          Empleo, Cargo o Comisión
        </label>
        <br>
        <input class="form-control" type="text" name="nombre_cargo" v-validate="modelValidations.nombre_cargo" v-model="model.empleo_cargo_comision" placeholder="Nombre del Cargo" />
        <small class="text-danger" v-show="nombre_cargo.invalid">
          {{ getError('nombre_cargo') }}
        </small>
      </div>
      <div class="col-md-3 form-group">
        <label class="control-label">
          ¿ Está contratado por honorarios?
        </label><br>
        <p-radio name="honorarios" v-validate="modelValidations.honorarios" v-model="model.contratado_honorarios" label="1">SI</p-radio>
        <p-radio name="honorarios" v-validate="modelValidations.honorarios" v-model="model.contratado_honorarios" label="2">NO</p-radio>
        <small class="text-danger" v-show="honorarios.invalid">
          {{ getError('honorarios') }}
        </small>
      </div>
      <div class="col-md-3 form-group">
        <label class="control-label">
          Nivel del empleo, cargo o comisión
        </label>
        <br>
        <input class="form-control" type="text" name="nivel" v-validate="modelValidations.nivel" v-model="model.nivel_encargo" placeholder="Nivel" />
        <small class="text-danger" v-show="nivel.invalid">
          {{ getError('nivel') }}
        </small>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12 form-group">
        <label class="control-label">
          Especifique funcion principal:
        </label>
        <el-select clearable multiple class="select-default" v-model="model.funcionesp" width="100%" name="funciones" v-validate="modelValidations.funciones" placeholder="Multiple Select">
          <el-option v-for="option in funciones_p" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="funciones.invalid">
          {{ getError('funciones') }}
        </small>
      </div>
      <div class="col-md-8">
        <div class="form-group">
          <label class="control-label">
            Otras funciones:
          </label>
          <input class="form-control" type="text" name="cargopuesto" v-model="model.otras_funciones" placeholder="Otras funciones" />
        </div>
      </div>

      <div class="col-md-6 form-group">
        <label class="control-label">
          Fecha de toma de Posesión del empleo, cargo o comisión
        </label>
        <br>
        <el-date-picker disabled name="toma_posesion" value-format="dd-MM-yyyy" format="dd-MM-yyyy" v-validate="modelValidations.toma_posesion" v-model="model.fecha_posesion" :picker-options="opciones" type="date" placeholder="Selecciona">
        </el-date-picker>
        <small class="text-danger" v-show="toma_posesion.invalid">
          {{ getError('toma_posesion') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label">
          Teléfono Laboral
        </label>
        <input class="form-control" type="text" name="curp" v-model="model.telefono_laboral_numero" placeholder="Teléfono Laboral" />
      </div>
      <div class="col-md-2 form-group">
        <label class="control-label">
          Ext
        </label>
        <input class="form-control" type="text" name="curp" v-model="model.telefono_laboral_extension" placeholder="Teléfono Laboral" />
      </div>
    </div>

    <domicilio v-model="n_domicilio" titulo=" del empleo, cargo o comisión "></domicilio>
    <br><br>

    <br>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker
  } from "element-ui";

  import {
    mapFields
  } from "vee-validate";

  import Domicilio from "../Domicilio.vue";

  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      Domicilio
    },
    computed: {
      ...mapFields([
        "correo_laboral",
        "ente",
        "nombre_cargo",
        "nivel",
        "poder",
        "honorarios",
        "nivel_orden",
        "area",
        "toma_posesion",
        "sector",
        "funciones",
        "ambitoexp",
        "nombreins",
        "unidadadm",
        "jerarqexp",
        "fechaingreso",
        "sectorexp",
        "cargopuesto"
      ])
    },
    data() {
      return {
        opciones: {
          disabledDate(date) {
            return date > new Date();
          }
        },

        // grupo: null,
        mostrarCampos: false,
        ip_id: null,
        datePicker: "",
        poderes: {},
        niveles: {},
        funcionesArr: [],
        funcionesExpArr: [],
        list_experiencia: [],
        edit_item: null,
        add_item: false,
        entidadFed: null,
        municipios: null,
        localidades: null,
        localidad: null,
        entes: {},
        ambitos: {},
        funciones_p: {},
        sectores: {},
        model: {
          fecha_posesion: ''
        },
        modelexp: {},
        n_domicilio: {
          pais_id: 150, // México
          entidadF: 11, // Estado Guanajuato
          municipio: '',
          localidad: '',
          cp: '',
          colonia: '',
          vialidad: '',
          vialidad_nombre: '',
          ext: '',
          int: ''
        },
        modelValidations: {
          correo_laboral: {
            email: true
          },
          ente: {
            required: true
          },
          nombre_cargo: {
            required: true
          },
          nivel: {
            required: true
          },
          poder: {
            required: true
          },
          honorarios: {
            required: true
          },
          nivel_orden: {
            required: true
          },
          area: {
            required: true
          },
          toma_posesion: {
            required: true
          },
          sector: {
            required: true
          },
          funciones: {
            required: true
          }
        },
        modelExp: {
          ambitoexp: {
            required: true
          },
          nombreins: {
            required: true
          },
          unidadadm: {
            required: true
          },
          jerarqexp: {
            required: true
          },
          cargopuesto: {
            required: true
          },
          fecha_ingreso: {
            required: true
          }
        },
        fields_list: [
          "acciones",
          {
            key: "ambito_id",
            label: "Ámbito",
            tdClass: "text-left"
          },
          {
            key: "nivel_gobierno_id",
            label: "Nivel",
            tdClass: "text-left"
          },
          {
            key: "poder_ente_id",
            label: "Poder Jurídico",
            tdClass: "text-left"
          },
          {
            key: "nombre_institucion",
            label: "Nombre",
            tdClass: "text-left"
          },
          {
            key: "unidad_administrativa",
            label: "Unidad",
            tdClass: "text-left"
          },
          {
            key: "sector_industria_id",
            label: "Sector/Industria",
            tdClass: "text-left"
          },
          {
            key: "jerarquia_rango",
            label: "Jerarquia",
            tdClass: "text-left"
          },
          {
            key: "cargo_puesto",
            label: "Cargo/Puesto",
            tdClass: "text-left"
          },
          {
            key: "fecha_ingreso",
            label: "Fecha Ingreso",
            tdClass: "text-left"
          },
          {
            key: "fecha_salida",
            label: "Fecha Salida",
            tdClass: "text-left"
          },
          {
            key: "direccion_pais_id",
            label: "País",
            tdClass: "text-left"
          },
          {
            key: "direccion_entidad_federativa_id",
            label: "Entidad Federativa",
            tdClass: "text-left"
          },
          {
            key: "direccion_municipio_id",
            label: "Municipio",
            tdClass: "text-left"
          },
          {
            key: "direccion_cp",
            label: "CP",
            tdClass: "text-left"
          },
          {
            key: "direccion_numext",
            label: "Num Ext",
            tdClass: "text-left"
          },
          {
            key: "direccion_numint",
            label: "Num Int",
            tdClass: "text-left"
          }
        ]
      };
    },
    mounted() {
      this.checkCatalogs();
      this.mostrarCampos = 1;

    },
    created() {
      this.ip_id = this.getId();
      this.getInfLaboral();
      // this.grupo = this.getKey('grupo');
      this.getEntes();
      this.getSectores();
      this.getPoderes();
      this.getNivelesG();
      this.getAmbitos();
      this.getFunciones();
    },

    watch: {
      n_domicilio: {
        handler: function () {
          if (this.n_domicilio) {
            this.model.direccion_encargo_pais_id = this.n_domicilio.pais ? this.n_domicilio.pais : 150;
            this.model.direccion_encargo_entidad_federativa_id = this.n_domicilio.entidadF ? this.n_domicilio.entidadF : "";
            this.model.direccion_encargo_municipio_id = this.n_domicilio.municipio ? this.n_domicilio.municipio : "";
            this.model.direccion_encargo_localidad_id = this.n_domicilio.localidad ? this.n_domicilio.localidad : "";
            this.model.direccion_encargo_cp = this.n_domicilio.cp ? this.n_domicilio.cp : "";
            this.model.direccion_vialidad_nombre = this.n_domicilio.vialidad_nombre;
            this.model.direccion_vialidad_tipo = this.n_domicilio.vialidad;
            this.model.direccion_encargo_numext = this.n_domicilio.ext ? this.n_domicilio.ext : "";
            this.model.direccion_encargo_numint = this.n_domicilio.int ? this.n_domicilio.int : "";
            this.model.direccion_encargo_colonia = this.n_domicilio.colonia ? this.n_domicilio.colonia : "";
            this.model.domicilio_obs = this.n_domicilio.domicilio_observaciones ? this.n_domicilio.domicilio_observaciones : "";

          }
        },
        deep: true
      }
    },
    methods: {
      getError(fieldName) {
        return this.errors.first(fieldName);
      },
      validate() {
        return this.$validator.validateAll();
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      getAmbito(index) {
        var resp = "";
        if (this.ambitos) {
          this.ambitos.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getPoder(index) {
        var resp = "";
        if (this.poderes) {
          this.poderes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getNivel(index) {
        var resp = "";
        if (this.niveles) {
          this.niveles.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getSector(index) {
        var resp = "";
        if (this.sectores && index) {
          this.sectores.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getEnte(index) {
        var resp = " ";
        if (this.entes) {
          this.entes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.limpiaCampos();
        this.showItem();
        this.edit_item = null;
      },
      getInfLaboral() {
        var v = this;
        this.$http.get("otroEncargo/" + this.ip_id).then(
          response => {
            if (response.data.informacion != null) {
              this.model = response.data.informacion;
              this.model.contratado_honorarios = String(
                this.model.contratado_honorarios
              );
              $.each(response.data.informacion.funcionesp, function (key, value) {
                v.funcionesArr.push(value.funcion_id);
              });
              this.model.funcionesp = v.funcionesArr;
            }
            this.editDomicilio()
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        );
      },
      getEntes() {
        var v = this;
        this.$http.get("cat_ente_publico").then(
          response => {
            this.entes = response.data.entes_publicos;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        );
      },
      editDomicilio() {
        if (this.model) {
          console.log(this.model)
          this.n_domicilio = {
            'pais_id': this.model.direccion_encargo_pais_id,
            'entidadF': this.model.direccion_encargo_entidad_federativa_id,
            'municipio': this.model.direccion_encargo_municipio_id,
            'colonia': this.model.direccion_encargo_colonia,
            'cp': this.model.direccion_encargo_cp,
            'localidad': this.model.direccion_encargo_localidad_id,
            'ext': this.model.direccion_encargo_numext,
            'int': this.model.direccion_encargo_numint,
            'vialidad': this.model.direccion_vialidad_tipo,
            'vialidad_nombre': this.model.direccion_vialidad_nombre,
            'domicilio_observaciones': this.model.domicilio_obs
          }

        }
      },
      getSafe(fn, defaultVal) {
        try {
          return fn();
        } catch (e) {
          return defaultVal;
        }
      },
      showInput() {
        this.tags.inputVisible = true;
        this.$nextTick(() => {
          this.$refs.saveTagInput.$refs.input.focus();
        });
      },
      handleInputConfirm() {
        let inputValue = this.tags.inputValue;
        if (inputValue) {
          this.tags.dynamicTags.push(inputValue);
        }
        this.tags.inputVisible = false;
        this.tags.inputValue = "";
      },
      getPoderes() {
        this.$http.get("poderJuridico").then(
          response => {
            this.poderes = response.data.poderJuridico;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        );
      },
      getNivelesG() {
        /*this.$http.get("nivelGobierno").then(
          response => {
            this.niveles = response.data.nivelGobierno;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        );*/
        var unArray = [{
          id: 1,
          codigo: "EST",
          valor: "Estatal"
        }];
        this.niveles = unArray;
      },
      getAmbitos() {
        this.$http.get("ambitos").then(
          response => {
            this.ambitos = response.data.ambitos;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        );
      },
      getSectores() {
        this.$http.get("cat_sector_industria").then(
          response => {
            this.sectores = response.data.sectores;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        );
      },
      getFunciones() {
        this.$http.get("funcPrinc").then(
          response => {
            this.funciones_p = response.data.funciones;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        );
      }
    }
  };

</script>
<style>


</style>
